var TMQZ = TMQZ || {};

// Define the Trivia Quiz constructor
TMQZ.TriviaQuiz = function(quizContainer) {
    TMQZ.Quiz.call(this, quizContainer);

    this.score = 0;
};

// Extend the Quiz class
TMQZ.TriviaQuiz.prototype = Object.create(TMQZ.Quiz.prototype);
TMQZ.TriviaQuiz.prototype.constructor = TMQZ.TriviaQuiz;
TMQZ.TriviaQuiz.prototype.parent = TMQZ.Quiz.prototype;

/* Define TriviaQuiz methods */

TMQZ.TriviaQuiz.prototype.getResult = function() {
    var quizObj = this;

    this.score = this.choices.reduce(function(a, b) {
        return a + b;
    });

    for (var i = 0; i < quizObj.results.length; i++) {
        var result = quizObj.results[i];

        if( quizObj.score >= $(result).data('points-from') && quizObj.score <= $(result).data('points-to')  ) {
            var resultText = $(result).find('.tmqz-result-text');
            resultText.html(quizObj.replaceTokens(resultText.html()));

            quizObj.assignSharingClicks(result);
            quizObj.bindRetry(result);

            return result;
        }
    }
};

TMQZ.TriviaQuiz.prototype.replaceTokens = function(string) {
    var quizObj = this;

    string = quizObj.parent.replaceTokens.call(this, string);

    string = string.replace( '{%result value%}', quizObj.score );
    string = string.replace( '{%score%}', quizObj.score );

    return string;
};
